unit CalcDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Compiler;

type
  TRechnerForm = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    Edit3: TEdit;
    Edit2: TEdit;
    Edit5: TEdit;
    Edit4: TEdit;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    RadioGroup1: TRadioGroup;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    Memo3: TMemo;
    TabSheet4: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    SysWahl: TComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RadioGroup1Click(Sender: TObject);
    procedure DoCalc(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
  private
    { Private-Deklarationen }
    Bytes : Integer;
    Max,Halb : Integer;
    Changing : Boolean;
    Procedure Error(E : TEdit);
  public
    { Public-Deklarationen }
  end;

var
  RechnerForm: TRechnerForm = nil;

implementation

uses Tools, Decompiler, MainUnit;

{$R *.DFM}

procedure TRechnerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RechnerForm:=nil;
  Action:=caFree;
end;

procedure TRechnerForm.RadioGroup1Click(Sender: TObject);
begin
  Bytes:=RadioGroup1.ItemIndex+1;
  If Bytes=1 then Max:=255 else Max:=65535;
  Halb:=Max div 2;
  Changing:=False;
  DoCalc(Edit2);
end;

procedure TRechnerForm.DoCalc(Sender: TObject);
Var I,J : Integer;
    S : String;
begin
  If Changing then exit;
  I:=0;
  If Sender=Edit1 then begin
    S:=Trim(Edit1.Text);
    If Copy(S,1,2)<>'0x' then S:='0x'+S;
    try I:=StrToInt(S); except Error(Edit1); exit; end;
  end;
  If Sender=Edit2 then begin
    try I:=StrToInt(Edit2.Text); except Error(Edit2); exit; end;
  end;
  If Sender=Edit3 then begin
    If not BinToInt(Edit3.Text,I) then begin Error(Edit3); exit; end;
  end;
  If Sender=Edit4 then begin
    S:=Trim(Edit4.Text);
    If (S<>'') and (S[1]='-') then begin
      J:=-1; S:=Copy(S,2,MaxInt);
    end else J:=1;
    If Copy(S,1,2)<>'0x' then S:='0x'+S;
    try I:=J*StrToInt(S); except Error(Edit4); exit; end;
    If (I>Halb) or (I<-(Halb+1)) then begin Error(Edit4); exit; end;
    If I<0 then I:=ZweiKomplement(I,Bytes);
  end;
  If Sender=Edit5 then begin
    try I:=StrToInt(Edit5.Text); except Error(Edit5); exit; end;
    If (I>Halb) or (I<-(Halb+1)) then begin Error(Edit5); exit; end;
    If I<0 then I:=ZweiKomplement(I,Bytes);
  end;
  If (I<0) or (I>Max) then begin Error(Sender as TEdit); exit; end;

  Error(nil);
  Changing:=True;
  If Sender<>Edit1 then Edit1.Text:=IntToHex(I,1);
  If Sender<>Edit2 then Edit2.Text:=IntToStr(I);
  If Sender<>Edit3 then Edit3.Text:=IntToBin(I);
  I:=ZweiKomplementBack(I,Bytes);
  If Sender<>Edit4 then begin
    Edit4.Text:=IntToHex(Abs(I),1);
    If I<0 then Edit4.Text:='-'+Edit4.Text;
  end;
  If Sender<>Edit5 then Edit5.Text:=IntToStr(I);
  Changing:=False;
end;

procedure TRechnerForm.Error(E : TEdit);
begin
  Changing:=True;
  If E<>nil then begin
    If E<>Edit1 then Edit1.Text:='';
    If E<>Edit2 then Edit2.Text:='';
    If E<>Edit3 then Edit3.Text:='';
    If E<>Edit4 then Edit4.Text:='';
    If E<>Edit5 then Edit5.Text:='';
    E.Font.Color:=clRed;
  end else begin
    Edit1.Font.Color:=clBlack;
    Edit2.Font.Color:=clBlack;
    Edit3.Font.Color:=clBlack;
    Edit4.Font.Color:=clBlack;
    Edit5.Font.Color:=clBlack;
  end;
  Changing:=False;
end;

procedure TRechnerForm.Edit6Change(Sender: TObject);
Var St : TMemoryStream;
    S,T : String;
    I : Integer;
    B : Byte;
begin
  Memo1.Clear; S:=Trim(Edit6.Text); St:=TMemoryStream.Create;
  try
    while S<>'' do begin
      T:=Trim(Copy(S,1,2)); S:=Trim(Copy(S,3,MaxInt));
      try
        I:=StrToInt('0x'+T);
        If (I<0) or (I>255) then raise EConvertError.Create('');
        B:=I; St.Write(B,1);
      except
        Messagedlg('Im eingegebenen Code wurde das ungltige Zeichen "'+T+'" gefunden.',mtError,[mbOK],0);
        St.Clear; break;
      end;
    end;
    If St.Size>0 then begin
      St.Position:=0;
      while St.Position<St.Size do begin
        DecompileOp(St,S);
        Memo1.Lines.Add(S);
      end;
    end;
  finally
    St.Free;
  end;
end;

procedure TRechnerForm.Memo2Change(Sender: TObject);
Var Prg : TProgramm;
    St : TStrings;
begin
  Prg:=TProgramm.Create;
  try
    Memo3.Lines.Clear;
    try
      Prg.Compile(Memo2.Lines,False);
      St:=Prg.GetListing;
      St.Delete(0); St.Delete(0);
      Memo3.Lines.Assign(St);
      St.Free;
    except
      on E : ECompilerError do Memo3.Lines.Add(E.Message+' in Zeile '+IntToStr(E.Line));
    end;
  finally
    Prg.Free;
  end;
end;

procedure TRechnerForm.FormCreate(Sender: TObject);
begin
  If MainForm.WindowStyle.ItemIndex>=0 then
    BoundsRect:=MainForm.SetupData.WindowSetup[MainForm.WindowStyle.ItemIndex].CalcWnd;
  ClientHeight:=PageControl.Height+2;
  ClientWidth:=PageControl.Width+2;
  RadioGroup1Click(Sender);
  SysWahl.ItemIndex:=2;
  Edit7Change(Sender);
  Edit6Change(Sender);
end;

Function SimpleCalc(S : ShortString; Sys : Integer) : ShortString; external 'calc.dll';

procedure TRechnerForm.Edit7Change(Sender: TObject);
Var Sys : Integer;
    S : ShortString;
begin
  Sys:=10;
  Case SysWahl.ItemIndex of
    0 : Sys:=2;
    1 : Sys:=8;
    2 : Sys:=10;
    3 : Sys:=16;
  end;
  S:=Edit7.Text;
  Edit8.Text:=SimpleCalc(S,Sys);
end;

end.
