unit DisDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Outline, DirOutln, StdCtrls, FileCtrl, ComCtrls, Buttons;

type
  TDisAsmDlg = class(TForm)
    DirectoryOutline1: TDirectoryOutline;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Memo: TRichEdit;
    SaveDialog: TSaveDialog;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryOutline1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
    Function LoadFile(S : String) : TStream;
  public
    { Public-Deklarationen }
  end;

var
  DisAsmDlg: TDisAsmDlg;

implementation

uses Decompiler, MainUnit;

{$R *.DFM}

procedure TDisAsmDlg.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryOutline1.Drive:=DriveComboBox1.Drive;
end;

procedure TDisAsmDlg.DirectoryOutline1Change(Sender: TObject);
begin
  FileListBox1.Directory:=DirectoryOutline1.Directory;
end;

procedure TDisAsmDlg.BitBtn1Click(Sender: TObject);
begin
  If SaveDialog.Execute then Memo.Lines.SaveToFile(SaveDialog.FileName);
end;

procedure TDisAsmDlg.BitBtn2Click(Sender: TObject);
begin
  Memo.Print('');
end;

procedure TDisAsmDlg.BitBtn3Click(Sender: TObject);
begin
  Close;
end;

Function TDisAsmDlg.LoadFile(S : String) : TStream;
Var MSt : TMemoryStream;
    St : TStringList;
    X : Integer;
    C : Char;
    T : String;
    I : Integer;
    B : Byte;
begin
  MSt:=TMemoryStream.Create;
  MSt.LoadFromFile(S);
  MSt.Position:=0;
  For X:=0 to MSt.Size-1 do begin
    MSt.Read(C,1);
    If Pos(C,'0123456789abcdefABCDEF '+#10+#13)=0 then begin
      MSt.Position:=0; result:=MSt; exit;
    end;
  end;
  MSt.Position:=0; St:=TStringList.Create; St.LoadFromStream(MSt); MSt.Clear;
  while St.Count>0 do begin
    S:=St[0];
    while S<>'' do begin
      T:=Trim(Copy(S,1,2)); S:=Trim(Copy(S,3,MaxInt));
      try
        I:=StrToInt('0x'+T);
        If (I<0) or (I>255) then raise EConvertError.Create('');
        B:=I; MSt.Write(B,1);
      except
        Messagedlg('Im Code wurde das ungltige Zeichen "'+T+'" gefunden.',mtError,[mbOK],0);
        MSt.Free; result:=nil; exit;
      end;
    end;
    St.Delete(0);
  end;
  result:=MSt;
end;

procedure TDisAsmDlg.FileListBox1Change(Sender: TObject);
Var St : TStream;
    Str : TStrings;
begin
  If not FileExists(FileListBox1.FileName) then exit;
  St:=LoadFile(FileListBox1.FileName);
  If St=nil then exit;
  Str:=DecompilePrg(St);
  Memo.Visible:=False;
  Memo.Lines.BeginUpdate;
  Memo.Lines.Clear;
  Memo.Lines.AddStrings(Str);
  Memo.Lines.EndUpdate;
  Memo.Visible:=True;
  Str.Free; St.Free;
end;

procedure TDisAsmDlg.FormShow(Sender: TObject);
begin
  Memo.Font.Size:=MainForm.SetupData.FontSize;
end;

end.
