unit MotorDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls;

type
  TMotorForm = class(TForm)
    Image: TImage;
    PopupMenu1: TPopupMenu;
    Ausgabelschen1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Ausgabelschen1Click(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
    Last : Byte;
    Start : Boolean;
    Procedure DoMove(X,Y : Integer);
  public
    { Public-Deklarationen }
    Pos : TPoint;
    Function Work(B : Byte) : Byte;
    Procedure Reset;
  end;

var
  MotorForm: TMotorForm = nil;

Function MotorWork(B : Byte) : Byte;

implementation

uses MainUnit;

{$R *.DFM}

Function MotorWork(B : Byte) : Byte;
begin
  If Assigned(MotorForm) then result:=MotorForm.Work(B) else result:=B;
end;

procedure TMotorForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MotorForm:=nil;
  Action:=caFree;
end;

procedure TMotorForm.FormCreate(Sender: TObject);
begin
  If MainForm.WindowStyle.ItemIndex>=0 then
    BoundsRect:=MainForm.SetupData.WindowSetup[MainForm.WindowStyle.ItemIndex].MotorWnd;
  Image.Picture.Bitmap.Width:=500;
  Image.Picture.Bitmap.Height:=500;
  Reset;
end;

procedure TMotorForm.Ausgabelschen1Click(Sender: TObject);
begin
  with Image.Picture.Bitmap.Canvas do begin
    Brush.Color:=$F0F0F0;
    Brush.Style:=bsSolid;
    FillRect(Rect(0,0,499,499));
    Pixels[Pos.X,Pos.Y]:=clRed;
  end;
end;

function TMotorForm.Work(B: Byte): Byte;
begin
  If Start or ((Last mod 4)=(B mod 4)) then Start:=False else begin
    If (Last and 1) <> (B and 1) then begin
      If B and 4 =4 then DoMove(1,0) else DoMove(-1,0);
    end;
    If (Last and 2) <> (B and 2) then begin
      If B and 8 =8 then DoMove(0,1) else DoMove(0,-1);
    end;
    Last:=B;
  end;
  If Pos.X=499 then B:=B or $10 else B:=B and $EF;
  If Pos.X=0 then B:=B or $20 else B:=B and $DF;
  If Pos.Y=499 then B:=B or $40 else B:=B and $BF;
  If Pos.Y=0 then B:=B or $80 else B:=B and $7F;
  result:=B;
end;

procedure TMotorForm.Reset;
begin
  Start:=True; Pos:=Point(250,250);
  Ausgabelschen1Click(self);
end;

procedure TMotorForm.DoMove(X, Y: Integer);
Var I : Cardinal;
begin
  with Image.Picture.Bitmap.Canvas do begin
    Pixels[Pos.X,Pos.Y]:=clBlack;
    inc(Pos.X,X); inc(Pos.Y,Y);
    If Pos.X<0 then Pos.X:=0;
    If Pos.X>499 then Pos.X:=499;
    If Pos.Y<0 then Pos.Y:=0;
    If Pos.Y>499 then Pos.Y:=499;
    Pixels[Pos.X,Pos.Y]:=clRed;
  end;
  Image.Refresh;
  I:=GetTickCount;
  while GetTickCount<=I do Application.ProcessMessages;
end;

procedure TMotorForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with Image.Picture.Bitmap.Canvas do begin
    Pixels[Pos.X,Pos.Y]:=clBlack;
    Pos.X:=X; Pos.Y:=Y;
    Pixels[Pos.X,Pos.Y]:=clRed;
  end;
end;

procedure TMotorForm.FormResize(Sender: TObject);
begin
  ClientWidth:=500; ClientHeight:=500;
end;

end.

