unit RunDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, AppEvnts, Menus, ComCtrls;

type
  TRunForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ApplicationEvents1: TApplicationEvents;
    BitBtn3: TBitBtn;
    PopupMenu1: TPopupMenu;
    GroupBox1: TGroupBox;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    ComboBox2: TComboBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit5: TEdit;
    Edit6: TEdit;
    ComboBox3: TComboBox;
    CheckBox5: TCheckBox;
    GroupBox3: TGroupBox;
    Memo: TRichEdit;
    PopupMenu2: TPopupMenu;
    Lschen1: TMenuItem;
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IRQRequest(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure MemoKeyPress(Sender: TObject; var Key: Char);
    procedure Lschen1Click(Sender: TObject);
    procedure MemoContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
  private
    { Private-Deklarationen }
    Start : Integer;
    Test : Boolean;
    LastAdd : Char;
    Function GetValue(I : Integer; S : String) : String;
  public
    { Public-Deklarationen }
    Procedure AddChar(C : Char);
  end;

var
  RunForm: TRunForm = nil;

Function RunPrg : Boolean; {True=Ende; False=Unterbrochen}

implementation

uses MainUnit, PrgConst, Tools;

{$R *.DFM}

Function RunPrg : Boolean;
begin
  RunForm:=TRunForm.Create(MainForm);
  try
    result:=(RunForm.ShowModal=mrOK);
  finally
    RunForm.Free;
    RunForm:=nil;
  end;
end;

procedure TRunForm.ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
Var P3 : Byte;
begin
  ApplicationEvents1.OnIdle:=nil;
  Done:=False;
  while ModalResult=mrNone do begin
    If not MainForm.PrgStep(False,Test) then ModalResult:=mrCancel;
    If MainForm.Breakpoints.IndexOf(Pointer(MainForm.System8051.ALU.Reg.PC))>=0 then begin
      MessageDlg('Die Programmausfhrung hat den Haltepunkt 0x'+IntToHex(MainForm.System8051.ALU.Reg.PC,4)+' erreicht.',mtInformation,[mbOK],0);
      ModalResult:=mrOK;
    end;
    MainForm.SetLEDs;
    P3:=MainForm.System8051.SFRArea[RegP3];
    CheckBox1.Checked:=(P3 and 4 = 4);
    CheckBox2.Checked:=(P3 and 8 = 8);
    If CheckBox3.Checked then ComboBox1Change(self);
    If CheckBox4.Checked then ComboBox2Change(self);
    If CheckBox5.Checked then ComboBox3Change(self);
    Application.ProcessMessages;
  end;
  ApplicationEvents1.OnIdle:=ApplicationEvents1Idle;
end;

procedure TRunForm.FormShow(Sender: TObject);
begin
  Start:=GetTickCount;
  Test:=(MainForm.System8051.Programm.Takte>0);
  ComboBox1.ItemIndex:=0; ComboBox2.ItemIndex:=0; ComboBox3.ItemIndex:=0;
end;

procedure TRunForm.FormClose(Sender: TObject; var Action: TCloseAction);
Var Zeit,I : Integer;
    S : String;
begin
  Zeit:=GetTickCount; Zeit:=Zeit-Start;
  If MainForm.System8051.Programm.Takte>0 then begin
    ApplicationEvents1.OnIdle:=nil;
    I:=1000*MainForm.System8051.Programm.Takte div Zeit;
    S:=IntToStr(I mod 1000); while length(S)<3 do S:='0'+S;
    MessageDlg('Der 8051 Emulator hat dieses Programm mit '+
    IntToStr(I div 1000)+','+S+'KHz abgearbeitet.',mtInformation,[mbOk],0);
  end;
end;

procedure TRunForm.IRQRequest(Sender: TObject);
begin
  MainForm.System8051.ALU.Reg.RequestIRQ((Sender as TMenuItem).Tag);
end;

procedure TRunForm.BitBtn3Click(Sender: TObject);
Var P : TPoint;
begin
  P:=ClientToScreen(Point(BitBtn3.Left,BitBtn3.Top));
  PopupMenu1.Popup(P.X,P.Y);
end;

procedure TRunForm.BitBtn4Click(Sender: TObject);
begin
  Case (Sender as TBitBtn).Tag of
    0 : MainForm.System8051.ALU.T0Click:=True;
    1 : MainForm.System8051.ALU.T1Click:=True;
  end;
end;

procedure TRunForm.CheckBox1Click(Sender: TObject);
Var P3 : Byte;
begin
  P3:=MainForm.System8051.SFRArea[RegP3];
  If TCheckBox(Sender).Checked
    then P3:=P3 or (1 shl (2+TCheckBox(Sender).Tag))
    else P3:=P3 and (255-(1 shl (2+TCheckBox(Sender).Tag)));
  MainForm.System8051.SFRArea[RegP3]:=P3;
end;

function TRunForm.GetValue(I: Integer; S: String): String;
Var A,V : Integer;
begin
  If I<3 then begin
    A:=-1;
    If I=1 then begin
      A:=AllTimeTab.IndexOf(ExtLowerCase(S));
      If A>=0 then A:=Integer(AllTimeTab.Objects[A]);
    end;
    If A<0 then begin
      If not IsByteZahl(S) then begin result:='ungltige Adresse'; exit; end;
      A:=StrToInt(S);
    end;
  end else begin
    If not IsWordZahl(S) then begin result:='ungltige Adresse'; exit; end;
    A:=StrToInt(S);
  end;
  Case I of
    0 : V:=MainForm.System8051.Data[A];
    1 : V:=MainForm.System8051.SFRArea[A];
    2 : V:=MainForm.System8051.XRAM[A];
    3 : V:=MainForm.System8051.Ext[A];
    4 : V:=MainForm.System8051.Code[A];
    else V:=0;
  end;
  result:='0x'+IntToHex(V,2)+' = '+IntToStr(V);
end;

procedure TRunForm.ComboBox1Change(Sender: TObject);
begin
  Edit2.Text:=GetValue(ComboBox1.ItemIndex,Edit1.Text);
end;

procedure TRunForm.ComboBox2Change(Sender: TObject);
begin
  Edit3.Text:=GetValue(ComboBox2.ItemIndex,Edit4.Text);
end;

procedure TRunForm.ComboBox3Change(Sender: TObject);
begin
  Edit5.Text:=GetValue(ComboBox3.ItemIndex,Edit6.Text);
end;

procedure TRunForm.CheckBox3Click(Sender: TObject);
begin
  ComboBox1.Enabled:=CheckBox3.Checked;
  Edit1.Enabled:=CheckBox3.Checked;
end;

procedure TRunForm.CheckBox4Click(Sender: TObject);
begin
  ComboBox2.Enabled:=CheckBox4.Checked;
  Edit4.Enabled:=CheckBox4.Checked;
end;

procedure TRunForm.CheckBox5Click(Sender: TObject);
begin
  ComboBox3.Enabled:=CheckBox5.Checked;
  Edit6.Enabled:=CheckBox5.Checked;
end;

procedure TRunForm.MemoKeyPress(Sender: TObject; var Key: Char);
begin
  MainForm.System8051.ALU.SeriellInBuffer:=MainForm.System8051.ALU.SeriellInBuffer+Key;
  Key:=#0;
end;

procedure TRunForm.AddChar(C: Char);
begin
  If (C=#13) or (C=#10) then begin
    If ((LastAdd<>#10) and (LastAdd<>#13)) or (LastAdd=C) then Memo.Lines.Add('');
  end else
  Memo.Lines[Memo.Lines.Count-1]:=Memo.Lines[Memo.Lines.Count-1]+C;
  LastAdd:=C;
end;

procedure TRunForm.Lschen1Click(Sender: TObject);
begin
  Memo.Clear;
  Memo.Lines.Add('');
end;

procedure TRunForm.MemoContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
  Handled:=True;
  MousePos:=Memo.ClientToScreen(MousePos);
  PopupMenu2.Popup(MousePos.X,MousePos.Y);
end;

end.
